Loading...
Searching...
No Matches
juce::AudioProcessorValueTreeState::Parameter Class Referencefinal

## Detailed Description

A parameter class that maintains backwards compatibility with deprecated AudioProcessorValueTreeState functionality.

Previous calls to

createAndAddParameter (paramID1, paramName1, ...);
juce::AudioProcessorValueTreeState::createAndAddParameter
RangedAudioParameter * createAndAddParameter(std::unique_ptr< RangedAudioParameter > parameter)
This function adds a parameter to the attached AudioProcessor and that parameter will be managed by t...

can be replaced with

using Parameter = AudioProcessorValueTreeState::Parameter;
createAndAddParameter (std::make_unique<Parameter> (paramID1, paramName1, ...));
juce::AudioProcessorValueTreeState::Parameter
A parameter class that maintains backwards compatibility with deprecated AudioProcessorValueTreeState...
Definition juce_AudioProcessorValueTreeState.h:456
juce::AudioProcessorValueTreeState::Parameter::Parameter
Parameter(const ParameterID &parameterID, const String &parameterName, NormalisableRange< float > valueRange, float defaultValue, const AudioProcessorValueTreeStateParameterAttributes &attributes={})
Constructs a parameter instance.

However, a much better approach is to use the AudioProcessorValueTreeState constructor directly

using Parameter = AudioProcessorValueTreeState::Parameter;
YourAudioProcessor()
: apvts (*this, &undoManager, "PARAMETERS", { std::make_unique<Parameter> (paramID1, paramName1, ...),
std::make_unique<Parameter> (paramID2, paramName2, ...),
... })
juce::AudioProcessorValueTreeState::undoManager
UndoManager *const undoManager
Provides access to the undo manager that this object is using.
Definition juce_AudioProcessorValueTreeState.h:420

The documentation for this class was generated from the following file:

- juce_audio_processors/utilities/juce_AudioProcessorValueTreeState.h

Inheritance diagram for juce::AudioProcessorValueTreeState::Parameter:

## Public Member Functions

| Parameter (const ParameterID &parameterID, const String &parameterName, NormalisableRange< float > valueRange, float defaultValue, const AudioProcessorValueTreeStateParameterAttributes &attributes={})
| Constructs a parameter instance.

Parameter (const ParameterID &parameterID, const String &parameterName, const String &labelText, NormalisableRange< float > valueRange, float defaultParameterValue, std::function< String(float)> valueToTextFunction, std::function< float(const String &)> textToValueFunction, bool isMetaParameter=false, bool isAutomatableParameter=true, bool isDiscrete=false, AudioProcessorParameter::Category parameterCategory=AudioProcessorParameter::genericParameter, bool isBoolean=false)

float | getDefaultValue () const override
| This should return the default value for this parameter.
int | getNumSteps () const override
| Returns the number of steps that this parameter's range should be quantised into.
bool | isDiscrete () const override
| Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously.
bool | isBoolean () const override
| Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states.
Public Member Functions inherited from juce::AudioParameterFloat
| AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, NormalisableRange< float > normalisableRange, float defaultValue, const AudioParameterFloatAttributes &attributes={})
| Creates a AudioParameterFloat with the specified parameters.

AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, NormalisableRange< float > normalisableRange, float defaultValue, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter, std::function< String(float value, int maximumStringLength)> stringFromValue=nullptr, std::function< float(const String &text)> valueFromString=nullptr)

| Creates a AudioParameterFloat with the specified parameters.
| AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, float minValue, float maxValue, float defaultValue)
| Creates a AudioParameterFloat with an ID, name, and range.
| ~AudioParameterFloat () override
| Destructor.
float | get () const noexcept
| Returns the parameter's current value.
| operator float () const noexcept
| Returns the parameter's current value.
AudioParameterFloat & | operator= (float newValue)
| Changes the parameter's current value.
const NormalisableRange< float > & | getNormalisableRange () const override
| Returns the range of values that the parameter can take.
Public Member Functions inherited from juce::RangedAudioParameter
int | getNumSteps () const override
| Returns the number of steps for this parameter based on the normalisable range's interval.
float | convertTo0to1 (float v) const noexcept
| Normalises and snaps a value based on the normalisable range.
float | convertFrom0to1 (float v) const noexcept
| Denormalises and snaps a value based on the normalisable range.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
Public Member Functions inherited from juce::AudioProcessorParameterWithID
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length.
String | getLabel () const override
| Some parameters may be able to return a label string for their units.
Category | getCategory () const override
| Returns the parameter's category.
String | getParameterID () const override
| Returns an ID that is unique to this parameter.
bool | isMetaParameter () const override
| Should return true if this parameter is a "meta" parameter.
bool | isAutomatable () const override
| Returns true if the host can automate this parameter.
bool | isOrientationInverted () const override
| This can be overridden to tell the host that this parameter operates in the reverse direction.
Public Member Functions inherited from juce::HostedAudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
Public Member Functions inherited from juce::AudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
virtual | ~AudioProcessorParameter ()
| Destructor.
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters.
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter.
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter.
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list.
void | setParameterIndex (int) noexcept
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String.
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in.
int | getVersionHint () const
void | setOwner (Listener *listener) noexcept
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes.
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener.
void | sendValueChangedMessageToListeners (float newValue)

## Additional Inherited Members

Public Types inherited from juce::AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }
Static Public Member Functions inherited from juce::AudioProcessorParameter
static int | getDefaultNumParameterSteps () noexcept
| Returns the default number of steps for a parameter.
Public Attributes inherited from juce::AudioParameterFloat
NormalisableRange< float > | range
| Provides access to the parameter's range.
Public Attributes inherited from juce::AudioProcessorParameterWithID
const String | paramID
| Provides access to the parameter's ID string.
const String | name
| Provides access to the parameter's name.
const String | label
| Provides access to the parameter's label.
const Category | category
| Provides access to the parameter's category.

## Constructors and Destructors

## Parameter() [1/2]

juce::AudioProcessorValueTreeState::Parameter::Parameter | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | NormalisableRange< float > | valueRange,
|  | float | defaultValue,
|  | const AudioProcessorValueTreeStateParameterAttributes & | attributes = {} )

Constructs a parameter instance.

Example usage:

using Parameter = AudioProcessorValueTreeState::Parameter;
using Attributes = AudioProcessorValueTreeStateParameterAttributes;
auto parameter = std::make_unique<Parameter> (ParameterID { "uniqueID", 1 },
"Name",
NormalisableRange<float> { 0.0f, 100.0f },
50.0f,
Attributes().withStringFromValueFunction (myStringFromValueFunction)
.withValueFromStringFunction (myValueFromStringFunction)
.withLabel ("%"));
juce::AudioProcessorValueTreeStateParameterAttributes
Advanced properties of an AudioProcessorValueTreeState::Parameter.
Definition juce_AudioProcessorValueTreeState.h:48
juce::NormalisableRange
Represents a mapping between an arbitrary range of values and a normalised 0->1 range.
Definition juce_NormalisableRange.h:52
juce::ParameterID
Combines a parameter ID and a version hint.
Definition juce_AudioProcessorParameterWithID.h:44

Parameters

  parameterID | The globally-unique identifier of this parameter
  parameterName | The user-facing name of this parameter
  valueRange | The valid range of values for this parameter
  defaultValue | The initial parameter value
  attributes | Further advanced settings to customise the behaviour of this parameter

Referenced by Parameter().

## Parameter() [2/2]

juce::AudioProcessorValueTreeState::Parameter::Parameter | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | const String & | labelText,
|  | NormalisableRange< float > | valueRange,
|  | float | defaultParameterValue,
|  | std::function< String(float)> | valueToTextFunction,
|  | std::function< float(const String &)> | textToValueFunction,
|  | bool | isMetaParameter = false,
|  | bool | isAutomatableParameter = true,
|  | bool | isDiscrete = false,
|  | AudioProcessorParameter::Category | parameterCategory = AudioProcessorParameter::genericParameter,
|  | bool | isBoolean = false )

inline

References juce::AudioProcessorParameter::genericParameter, isBoolean(), isDiscrete(), juce::AudioProcessorParameterWithID::isMetaParameter(), and Parameter().

## Member Functions

## getDefaultValue()

float juce::AudioProcessorValueTreeState::Parameter::getDefaultValue | ( |  | ) | const

override virtual

This should return the default value for this parameter.

Reimplemented from juce::AudioParameterFloat.

## getNumSteps()

int juce::AudioProcessorValueTreeState::Parameter::getNumSteps | ( |  | ) | const

override virtual

Returns the number of steps that this parameter's range should be quantised into.

If you want a continuous range of values, don't override this method, and allow the default implementation to return getDefaultNumParameterSteps().

If your parameter is boolean, then you may want to make this return 2.

The value that is returned may or may not be used, depending on the host. If you want the host to display stepped automation values, rather than a continuous interpolation between successive values, you should override isDiscrete to return true.

See also
  isDiscrete

Reimplemented from juce::AudioParameterFloat.

## isDiscrete()

bool juce::AudioProcessorValueTreeState::Parameter::isDiscrete | ( |  | ) | const

override virtual

Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously.

This information may or may not be used, depending on the host. If you want the host to display stepped automation values, rather than a continuous interpolation between successive values, override this method to return true.

See also
  getNumSteps

Reimplemented from juce::AudioProcessorParameter.

Referenced by Parameter().

## isBoolean()

bool juce::AudioProcessorValueTreeState::Parameter::isBoolean | ( |  | ) | const

override virtual

Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states.

This information may or may not be used, depending on the host. If you want the host to display a switch, rather than a two item dropdown menu, override this method to return true. You also need to override isDiscrete() to return true and getNumSteps() to return 2.

See also
  isDiscrete getNumSteps

Reimplemented from juce::AudioProcessorParameter.

Referenced by Parameter().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited